REM  Windows batch file to compile and register a new component

REM @echo off

REM add for ODK, JDK, and office
set ODKPATH=f:\odk627
set OFFICEPROGRAMPATH=D:\office60\program
set WORKINGDIRECTORY=e:\Trash\CalcAddins
set PATH=%PATH%;%ODKPATH%\windows\bin;D:\jdk1.3\bin;%OFFICEPROGRAMPATH%

REM use the uno compiler in order to create the URD-file
REM unoidl -I%ODKPATH%\idl XCalcAddins.idl
idlc -I%ODKPATH%\idl XCalcAddins.idl

REM regview XCalcAddins.urd

REM
regmerge Types.rdb /UCR XCalcAddins.urd
regmerge %OFFICEPROGRAMPATH%\applicat.rdb / Types.rdb

REM regview Types.rdb

REM create a java-file XCalcAddins.java
javamaker -Tcom.sun.star.sheet.addin.XCalcAddins -BUCR Types.rdb %ODKPATH%\windows\bin\applicat.rdb

REM type com\sun\star\sheet\addin\XCalcAddins.java

REM compile all java-files
javac -classpath %OFFICEPROGRAMPATH%\classes\unoil.jar;%OFFICEPROGRAMPATH%\classes\ridl.jar;%OFFICEPROGRAMPATH%\classes\jurt.jar com\sun\star\sheet\addin\XCalcAddins.java CalcAddins.java

REM create a jar-file with Manifest
jar -cvfm CalcAddins.jar Manifest .\com\sun\star\sheet\addin\XCalcAddins.class .\CalcAddins.class .\CalcAddins$_CalcAddins.class

REM change directory
REM cd %OFFICEPROGRAMPATH%\classes

REM registering the service, id est the jar-file
REM java -classpath %OFFICEPROGRAMPATH%\classes\unoil.jar;%OFFICEPROGRAMPATH%\classes\sandbox.jar;%OFFICEPROGRAMPATH%\classes\jut.jar;%OFFICEPROGRAMPATH%\classes\java_uno.jar;%OFFICEPROGRAMPATH%\classes\ridl.jar;%OFFICEPROGRAMPATH%\classes\jurt.jar;%OFFICEPROGRAMPATH%\classes\juh.jar com.sun.star.tools.uno.RegComp %OFFICEPROGRAMPATH%\applicat.rdb register "file:///e:/Trash/CalcAddins/CalcAddins.jar" com.sun.star.loader.Java2
